/*
   Class Name:

      CCamera.

   Created by:

      Allen Sherrod (Programming Ace of www.UltimateGameProgramming.com).

   Description:

      This class represents a camera in a 3D scene.
*/


#ifndef CCAMERA_H
#define CCAMERA_H

#include<math.h>                          // Math header that allows us to use cos() and sin().

#define UP              0.01f             // Forward speed.
#define DOWN            -0.01f            // Backward speed.
#define LEFT            0.01f             // Left speed.
#define RIGHT           -0.01f            // Right speed.


class CCamera
{
   public:
      CCamera();

      void SetCamera(float x, float y, float z,
                     float xv, float yv, float zv,
                     float xu, float yu, float zu);

      void MoveCamera(float direction);
      void RotateCamera(float AngleDir, float xSpeed,
                        float ySpeed, float zSpeed);

      float xPos, yPos, zPos;             // Camera position.
      float xView, yView, zView;          // Look at position.
      float xUp, yUp, zUp;                // Up direction.
};

#endif


// Copyright October 2004
// All Rights Reserved!
// Allen Sherrod
// ProgrammingAce@UltimateGameProgramming.com
// www.UltimateGameProgramming.com